package net.knarcraft.blockhunt;

import me.libraryaddict.disguise.DisguiseAPI;
import me.libraryaddict.disguise.disguisetypes.DisguiseType;
import me.libraryaddict.disguise.disguisetypes.MiscDisguise;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.util.MessageHelper;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.block.Block;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import java.util.logging.Level;

public class SolidBlockHandler {

    public static void makePlayerUnsolid(Player player) {
        ItemStack block = player.getInventory().getItem(8);
        if (block == null) {
            player.sendMessage(ChatColor.RED + "Unable to hide you because your inventory block is missing!");
            BlockHunt.plugin.getLogger().log(Level.SEVERE, player.getName() + " could not be hidden because " +
                    "their inventory block was missing!");
            return;
        }

        Block pBlock = player.getLocation().getBlock();

        if (MemoryStorage.hiddenLocation.get(player) != null) {
            pBlock = MemoryStorage.hiddenLocation.get(player).getBlock();
        }

        block.setAmount(5);
        for (Player pl : Bukkit.getOnlinePlayers()) {
            if (pl.equals(player)) {
                continue;
            }
            if (MemoryStorage.hiddenLocationWater.get(player) != null) {
                if (MemoryStorage.hiddenLocationWater.get(player)) {
                    pl.sendBlockChange(pBlock.getLocation(), Bukkit.createBlockData(Material.WATER));
                } else {
                    pl.sendBlockChange(pBlock.getLocation(), Bukkit.createBlockData(Material.AIR));
                }
            } else {
                pl.sendBlockChange(pBlock.getLocation(), Bukkit.createBlockData(Material.AIR));
            }

            MemoryStorage.hiddenLocationWater.remove(player);
        }

        player.playSound(player.getLocation(), Sound.ENTITY_BAT_HURT, 1, 1);
        block.removeEnchantment(Enchantment.DURABILITY);

        for (Player playerShow : Bukkit.getOnlinePlayers()) {
            playerShow.showPlayer(BlockHunt.plugin, player);
        }

        MiscDisguise disguise = new MiscDisguise(DisguiseType.FALLING_BLOCK, block.getType());
        DisguiseAPI.disguiseToAll(player, disguise);

        MessageHelper.sendMessage(player, MessageKey.NORMAL_IN_GAME_NO_MORE_SOLID);
    }

}
