package net.knarcraft.blockhunt.util;

public final class StringHelper {

    private StringHelper() {

    }

    /**
     * Turns the first character of each of a string's words into uppercase
     *
     * @param input <p>The input to uppercase</p>
     * @return <p>The input string with more uppercase</p>
     */
    public static String uppercaseAllFirst(String input) {
        String[] parts = input.split(" ");
        for (int i = 0; i < parts.length; i++) {
            parts[i] = parts[i].substring(0, 1).toUpperCase() + parts[i].substring(1);
        }
        return String.join(" ", parts);
    }

    /**
     * Gets an object array as a string array by running toString
     *
     * @param array <p>The input array</p>
     * @return <p>The resulting string array</p>
     */
    public static String[] toString(Object[] array) {
        String[] output = new String[array.length];
        for (int i = 0; i < array.length; i++) {
            output[i] = array[i].toString();
        }
        return output;
    }

}
